﻿using System;
namespace HeartTrack.Services.ActivityDataService
{
	public class ActivityDataServiceAPI : IActivityDataService
	{
		[Inject]
        private HttpClient _clientHttp { get; set; }


        public ActivityDataServiceFactice(HttpClient clientHttp)
        {
            this._clientHttp = clientHttp;
        }

        public async Task AddActivity(Activity a)
        {
			HttpResponseMessage response = await _clientHttp.PostAsJsonAsync("http://localhost:8080/api/activities", a);

			if (response.IsSuccessStatusCode)
			{
				// La requête a réussi
			}
			else
			{
				// La requête a échoué
			}
        }

        public async Task<Activity> getActivityById(int id)
        {
			Activity activity = await _clientHttp.GetFromJsonAsync<List<Activity>>("http://localhost:8080/api/activities/{id}");
			return activity;
        }

        public async Task<List<Activity>> getAllActivities()
        {
			List<Activity> lActivities = await _clientHttp.GetFromJsonAsync<List<Activity>>("http://localhost:8080/api/activities");
            return lActivities;
        }

        public async Task RemoveActivity(Activity a)
        {
			HttpResponseMessage response = await _clientHttp.DeleteAsync($"http://localhost:8080/api/activities/{a.IdActivity}");

			if (response.IsSuccessStatusCode)
			{
				// La requête a réussi
			}
			else
			{
				// La requête a échoué
			}
        }

        public async Task SaveAllActivities(List<Activity> list)
        {
			HttpResponseMessage response = await _clientHttp.PutAsJsonAsync("http://localhost:8080/api/activities", list);

			if (response.IsSuccessStatusCode)
			{
				// La requête a réussi
			}
			else
			{
				// La requête a échoué
			}
        }

        public async Task UpdateActivity(Activity a)
        {
			HttpResponseMessage response = await _clientHttp.PutAsJsonAsync($"http://localhost:8080/api/activities/{a.IdActivity}", a);

			if (response.IsSuccessStatusCode)
			{
				// La requête a réussi
			}
			else
			{
				// La requête a échoué
			}
        }
	}
}

